package com.app.markeet.utils;

import android.text.TextUtils;

import com.app.markeet.AppConfig;
import com.google.firebase.remoteconfig.FirebaseRemoteConfig;

import java.util.Locale;

import dreamspace.ads.sdk.data.AdNetworkType;

public class AppConfigExt {

    /* --------------- DON'T EDIT CODE BELOW ------------------------------------------------------ */

    // define static variable for all config class
    public static AppConfig.General general = new AppConfig.General();
    public static AppConfig.Ads ads = new AppConfig.Ads();

    // Set data from remote config
    public static void setFromRemoteConfig(FirebaseRemoteConfig remote) {
        // fetch General Config with data from remote config
        if (!remote.getString("admin_panel_url").isEmpty()) {
            AppConfig.general.admin_panel_url = remote.getString("admin_panel_url");
        }

        if (!remote.getString("security_code").isEmpty()) {
            AppConfig.general.security_code = remote.getString("security_code");
        }

        if (!remote.getString("tint_category_icon").isEmpty()) {
            AppConfig.general.tint_category_icon = Boolean.parseBoolean(remote.getString("tint_category_icon"));
        }

        if (!remote.getString("price_local_format").isEmpty()) {
            try {
                String format = remote.getString("price_local_format");
                if (TextUtils.isEmpty(format)) {
                    if (format.equals("US")) {
                        AppConfig.general.price_local_format = Locale.US;
                    } else if (format.equals("GERMANY")) {
                        AppConfig.general.price_local_format = Locale.GERMANY;
                    }
                }
            } catch (Exception e) {

            }
        }

        if (!remote.getString("price_with_decimal").isEmpty()) {
            AppConfig.general.price_with_decimal = Boolean.parseBoolean(remote.getString("price_with_decimal"));
        }

        if (!remote.getString("price_currency_in_end").isEmpty()) {
            AppConfig.general.price_currency_in_end = Boolean.parseBoolean(remote.getString("price_currency_in_end"));
        }

        if (!remote.getString("news_per_request").isEmpty()) {
            try {
                AppConfig.general.news_per_request = Integer.parseInt(remote.getString("news_per_request"));
            } catch (Exception e) {
            }
        }

        if (!remote.getString("product_per_request").isEmpty()) {
            try {
                AppConfig.general.product_per_request = Integer.parseInt(remote.getString("product_per_request"));
            } catch (Exception e) {
            }
        }

        if (!remote.getString("notification_page").isEmpty()) {
            try {
                AppConfig.general.notification_page = Integer.parseInt(remote.getString("notification_page"));
            } catch (Exception e) {
            }
        }

        if (!remote.getString("wishlist_page").isEmpty()) {
            try {
                AppConfig.general.wishlist_page = Integer.parseInt(remote.getString("wishlist_page"));
            } catch (Exception e) {
            }
        }

        if (!remote.getString("order_history_page").isEmpty()) {
            try {
                AppConfig.general.order_history_page = Integer.parseInt(remote.getString("order_history_page"));
            } catch (Exception e) {
            }
        }

        if (!remote.getString("privacy_policy_url").isEmpty()) {
            AppConfig.general.privacy_policy_url = remote.getString("privacy_policy_url");
        }
        if (!remote.getString("contact_us_url").isEmpty()) {
            AppConfig.general.contact_us_url = remote.getString("contact_us_url");
        }
        if (!remote.getString("update_app_url").isEmpty()) {
            AppConfig.general.update_app_url = remote.getString("update_app_url");
        }

        // fetch Ads Config with data from remote config
        if (!remote.getString("ad_enable").isEmpty()) {
            AppConfig.ads.ad_enable = Boolean.parseBoolean(remote.getString("ad_enable"));
        }

        if (!remote.getString("ad_networks").isEmpty()) {

            String[] arr = remote.getString("ad_networks").split(",");
            AdNetworkType[] adNetworkTypes = new AdNetworkType[arr.length];
            for (int i = 0; i < arr.length; i++) {
                try {
                    adNetworkTypes[i] = AdNetworkType.valueOf(arr[i].trim());
                } catch (Exception e) {

                }
            }
            AppConfig.ads.ad_networks = adNetworkTypes;
        }

        if (!remote.getString("retry_from_start_max").isEmpty()) {
            try {
                AppConfig.ads.retry_from_start_max = Integer.parseInt(remote.getString("retry_from_start_max"));
            } catch (Exception e) {
            }
        }

        if (!remote.getString("ad_enable_gdpr").isEmpty()) {
            AppConfig.ads.ad_enable_gdpr = Boolean.parseBoolean(remote.getString("ad_enable_gdpr"));
        }


        if (!remote.getString("ad_main_banner").isEmpty()) {
            AppConfig.ads.ad_main_banner = Boolean.parseBoolean(remote.getString("ad_main_banner"));
        }
        if (!remote.getString("ad_main_interstitial").isEmpty()) {
            AppConfig.ads.ad_main_interstitial = Boolean.parseBoolean(remote.getString("ad_main_interstitial"));
        }
        if (!remote.getString("ad_news_info_details").isEmpty()) {
            AppConfig.ads.ad_news_info_details = Boolean.parseBoolean(remote.getString("ad_news_info_details"));
        }
        if (!remote.getString("ad_product_details").isEmpty()) {
            AppConfig.ads.ad_product_details = Boolean.parseBoolean(remote.getString("ad_product_details"));
        }

        if (!remote.getString("ad_splash_open_app").isEmpty()) {
            AppConfig.ads.ad_splash_open_app = Boolean.parseBoolean(remote.getString("ad_splash_open_app"));
        }
        if (!remote.getString("ad_global_open_app").isEmpty()) {
            AppConfig.ads.ad_global_open_app = Boolean.parseBoolean(remote.getString("ad_global_open_app"));
        }

        if (!remote.getString("ad_replace_unsupported_open_app_with_interstitial_on_splash").isEmpty()) {
            AppConfig.ads.ad_replace_unsupported_open_app_with_interstitial_on_splash = Boolean.parseBoolean(remote.getString("ad_replace_unsupported_open_app_with_interstitial_on_splash"));
        }

        if (!remote.getString("ad_inters_interval").isEmpty()) {
            try {
                AppConfig.ads.ad_inters_interval = Integer.parseInt(remote.getString("ad_inters_interval"));
            } catch (Exception e) {
            }
        }

        if (!remote.getString("ad_admob_publisher_id").isEmpty()) {
            AppConfig.ads.ad_admob_publisher_id = remote.getString("ad_admob_publisher_id");
        }
        if (!remote.getString("ad_admob_banner_unit_id").isEmpty()) {
            AppConfig.ads.ad_admob_banner_unit_id = remote.getString("ad_admob_banner_unit_id");
        }
        if (!remote.getString("ad_admob_interstitial_unit_id").isEmpty()) {
            AppConfig.ads.ad_admob_interstitial_unit_id = remote.getString("ad_admob_interstitial_unit_id");
        }
        if (!remote.getString("ad_admob_rewarded_unit_id").isEmpty()) {
            AppConfig.ads.ad_admob_rewarded_unit_id = remote.getString("ad_admob_rewarded_unit_id");
        }
        if (!remote.getString("ad_admob_open_app_unit_id").isEmpty()) {
            AppConfig.ads.ad_admob_open_app_unit_id = remote.getString("ad_admob_open_app_unit_id");
        }


        if (!remote.getString("ad_manager_banner_unit_id").isEmpty()) {
            AppConfig.ads.ad_manager_banner_unit_id = remote.getString("ad_manager_banner_unit_id");
        }
        if (!remote.getString("ad_manager_interstitial_unit_id").isEmpty()) {
            AppConfig.ads.ad_manager_interstitial_unit_id = remote.getString("ad_manager_interstitial_unit_id");
        }
        if (!remote.getString("ad_manager_rewarded_unit_id").isEmpty()) {
            AppConfig.ads.ad_manager_rewarded_unit_id = remote.getString("ad_manager_rewarded_unit_id");
        }
        if (!remote.getString("ad_manager_open_app_unit_id").isEmpty()) {
            AppConfig.ads.ad_manager_open_app_unit_id = remote.getString("ad_manager_open_app_unit_id");
        }

        if (!remote.getString("ad_fan_banner_unit_id").isEmpty()) {
            AppConfig.ads.ad_fan_banner_unit_id = remote.getString("ad_fan_banner_unit_id");
        }
        if (!remote.getString("ad_fan_interstitial_unit_id").isEmpty()) {
            AppConfig.ads.ad_fan_banner_unit_id = remote.getString("ad_fan_banner_unit_id");
        }
        if (!remote.getString("ad_fan_rewarded_unit_id").isEmpty()) {
            AppConfig.ads.ad_fan_rewarded_unit_id = remote.getString("ad_fan_rewarded_unit_id");
        }

        if (!remote.getString("ad_ironsource_app_key").isEmpty()) {
            AppConfig.ads.ad_ironsource_app_key = remote.getString("ad_ironsource_app_key");
        }
        if (!remote.getString("ad_ironsource_banner_unit_id").isEmpty()) {
            AppConfig.ads.ad_ironsource_banner_unit_id = remote.getString("ad_ironsource_banner_unit_id");
        }
        if (!remote.getString("ad_ironsource_rewarded_unit_id").isEmpty()) {
            AppConfig.ads.ad_ironsource_rewarded_unit_id = remote.getString("ad_ironsource_rewarded_unit_id");
        }
        if (!remote.getString("ad_ironsource_interstitial_unit_id").isEmpty()) {
            AppConfig.ads.ad_ironsource_interstitial_unit_id = remote.getString("ad_ironsource_interstitial_unit_id");
        }

        if (!remote.getString("ad_unity_game_id").isEmpty()) {
            AppConfig.ads.ad_unity_game_id = remote.getString("ad_unity_game_id");
        }
        if (!remote.getString("ad_unity_banner_unit_id").isEmpty()) {
            AppConfig.ads.ad_unity_banner_unit_id = remote.getString("ad_unity_banner_unit_id");
        }
        if (!remote.getString("ad_unity_rewarded_unit_id").isEmpty()) {
            AppConfig.ads.ad_unity_rewarded_unit_id = remote.getString("ad_unity_rewarded_unit_id");
        }
        if (!remote.getString("ad_unity_interstitial_unit_id").isEmpty()) {
            AppConfig.ads.ad_unity_interstitial_unit_id = remote.getString("ad_unity_interstitial_unit_id");
        }

        if (!remote.getString("ad_applovin_banner_unit_id").isEmpty()) {
            AppConfig.ads.ad_applovin_banner_unit_id = remote.getString("ad_applovin_banner_unit_id");
        }
        if (!remote.getString("ad_applovin_interstitial_unit_id").isEmpty()) {
            AppConfig.ads.ad_applovin_interstitial_unit_id = remote.getString("ad_applovin_interstitial_unit_id");
        }
        if (!remote.getString("ad_applovin_rewarded_unit_id").isEmpty()) {
            AppConfig.ads.ad_applovin_rewarded_unit_id = remote.getString("ad_applovin_rewarded_unit_id");
        }
        if (!remote.getString("ad_applovin_open_app_unit_id").isEmpty()) {
            AppConfig.ads.ad_applovin_open_app_unit_id = remote.getString("ad_applovin_open_app_unit_id");
        }

        if (!remote.getString("ad_applovin_banner_zone_id").isEmpty()) {
            AppConfig.ads.ad_applovin_banner_zone_id = remote.getString("ad_applovin_banner_zone_id");
        }
        if (!remote.getString("ad_applovin_interstitial_zone_id").isEmpty()) {
            AppConfig.ads.ad_applovin_interstitial_zone_id = remote.getString("ad_applovin_interstitial_zone_id");
        }
        if (!remote.getString("ad_applovin_rewarded_zone_id").isEmpty()) {
            AppConfig.ads.ad_applovin_rewarded_zone_id = remote.getString("ad_applovin_rewarded_zone_id");
        }
        if (!remote.getString("ad_applovin_rewarded_zone_id").isEmpty()) {
            AppConfig.ads.ad_applovin_rewarded_zone_id = remote.getString("ad_applovin_rewarded_zone_id");
        }

        if (!remote.getString("ad_startapp_app_id").isEmpty()) {
            AppConfig.ads.ad_startapp_app_id = remote.getString("ad_startapp_app_id");
        }

        if (!remote.getString("ad_wortise_app_id").isEmpty()) {
            AppConfig.ads.ad_wortise_app_id = remote.getString("ad_wortise_app_id");
        }
        if (!remote.getString("ad_wortise_banner_unit_id").isEmpty()) {
            AppConfig.ads.ad_wortise_banner_unit_id = remote.getString("ad_wortise_banner_unit_id");
        }
        if (!remote.getString("ad_wortise_interstitial_unit_id").isEmpty()) {
            AppConfig.ads.ad_wortise_interstitial_unit_id = remote.getString("ad_wortise_interstitial_unit_id");
        }
        if (!remote.getString("ad_wortise_rewarded_unit_id").isEmpty()) {
            AppConfig.ads.ad_wortise_rewarded_unit_id = remote.getString("ad_wortise_rewarded_unit_id");
        }
        if (!remote.getString("ad_wortise_open_app_unit_id").isEmpty()) {
            AppConfig.ads.ad_wortise_open_app_unit_id = remote.getString("ad_wortise_open_app_unit_id");
        }

    }
}
